---
- hosts: dc1
  roles:
    - common
    - samba-dc
  tasks:
  - name: copy osync rpm
    copy:
      src: first-dc/osync-1.2-1.el7.centos.noarch.rpm
      dest: /root/osync-1.2-1.el7.centos.noarch.rpm
    become: yes

  - name: install osync
    yum:
      name: /root/osync-1.2-1.el7.centos.noarch.rpm
      state: present
    become: yes

  - name: install cronie
    yum:
      name: cronie
    become: yes

  - name: reconfigure dns (for samba)
    command: nmcli connection modify {{ hostvars[inventory_hostname]['ansible_default_ipv4']['alias'] }} ipv4.dns {{ hostvars[inventory_hostname]['ansible_default_ipv4']['address'] }} ipv4.dns-search {{ domain }}
    become: yes

  - name: restart network manager service
    systemd:
      name: NetworkManager
      enabled: yes
      state: restarted
    become: yes

  - name: samba domain provision
    command: "samba-tool domain provision --server-role=dc --use-rfc2307 --dns-backend=BIND9_DLZ --realm={{ domain|upper }} --domain=OFFICE --adminpass={{ password }}"
    become: yes

  - name: configure kerberos
    copy:
      src: /var/lib/samba/private/krb5.conf
      dest: /etc/krb5.conf
      remote_src: yes
    become: yes

  - name: configure named
    template:
      src: first-dc/named.conf.j2
      dest: /etc/named.conf
    become: yes

  - name: configure samba dns forwarder
    ini_file:
      path: /etc/samba/smb.conf
      section: global
      option: "dns forwarder"
      value: "{{ hostvars[inventory_hostname]['ansible_default_ipv4']['gateway'] }}"
    become: yes

  - name: start samba service
    systemd:
      name: samba
      enabled: yes
      state: restarted
    become: yes

  - name: start named service
    systemd:
      name: named
      enabled: yes
      state: restarted
    become: yes

  - name: create .ssh directory
    file:
      path: /root/.ssh
      state: directory
      owner: root
      group: root
      mode: "0700"
    become: yes

  - name: add ssh private key
    copy:
      src: first-dc/id_rsa
      dest: /root/.ssh/id_rsa
      owner: root
      group: root
      mode: "0600"
    become: yes

  - name: add ssh fingerprint
    lineinfile:
      path: /root/.ssh/known_hosts
      line: "{{ address_dc2 }} ecdsa-sha2-nistp256 AAAAE2VjZHNhLXNoYTItbmlzdHAyNTYAAAAIbmlzdHAyNTYAAABBBIFAe4vYHNQBTy9RO2jMSnfMv7EcjSoKHk0iDgMbVYLfNUpR9WZ3X35xY38zwpnTvbJokw3Tnl8TQSddkEClRqg="
      create: yes
    become: yes

  - name: configure osync
    template:
      src: first-dc/sync.conf.j2
      dest: /etc/osync/sync.conf
    become: yes

  - name: add cron job
    cron:
      name: "sync sysvol"
      minute: "*/5"
      job: "/usr/bin/osync.sh /etc/osync/sync.conf --silent"
    become: yes

  - name: start cron
    systemd:
      name: crond
      enabled: yes
      state: restarted
    become: yes
